/**
 * Created by huangxiaogang on 16/8/5.
 */
/**
 * Created by huangxiaogang on 16/8/5.
 * react + redux 导出更加用户友好的API
 *
 *
 * {
 *  react:{
 *      root:'',
 *      Container:''
 *      },
 *  redux:{
 *      reducers:{},
 *      actions:{}
 *      middleware:[]
 *      },
 *  'react-redux':{
 *      stateToProps:fn
 *      }
 * }
 */

'use strict';

exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _redux = require('redux');

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require("react-redux");

var _reactDom = require("react-dom");

exports['default'] = function (config) {
    var _config$react = config['react'];
    var root = _config$react.root;
    var Container = _config$react.Container;
    var _config$redux = config['redux'];
    var reducers = _config$redux.reducers;
    var actions = _config$redux.actions;
    var middleware = _config$redux.middleware;
    var stateToProps = config['react-redux'].stateToProps;

    if (!(typeof stateToProps == 'function')) {
        stateToProps = function (state) {

            return state;
        };
    }
    var middleWareArr = [_reduxThunk2['default']];
    if (middleware) {
        middleWareArr = middleware.concat(middleWareArr);
    }

    var finalReducers = typeof reducers == 'function' ? reducers : _redux.combineReducers(reducers);

    var ConnectContainer = _reactRedux.connect(stateToProps, actions)(Container);

    var store = _redux.applyMiddleware.apply(null, middleWareArr)(_redux.createStore)(finalReducers);
    //创建react和redux联系起来的容器

    var ModuleContainer = (function (_Component) {
        _inherits(ModuleContainer, _Component);

        function ModuleContainer() {
            _classCallCheck(this, ModuleContainer);

            _Component.apply(this, arguments);
        }

        ModuleContainer.prototype.render = function render() {
            return _react2['default'].createElement(
                _reactRedux.Provider,
                { store: store },
                _react2['default'].createElement(ConnectContainer, null)
            );
        };

        return ModuleContainer;
    })(_react.Component);

    _reactDom.render(_react2['default'].createElement(ModuleContainer, null), root);
};

module.exports = exports['default'];